Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultOptimizer.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultOptimizer.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultOptimizer.java	(revision 44738)
@@ -7,6 +7,7 @@
 import org.gvsig.expressionevaluator.Code;
 import org.gvsig.expressionevaluator.Code.Caller;
 import org.gvsig.expressionevaluator.CodeBuilder;
+import org.gvsig.expressionevaluator.Codes;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
 import org.gvsig.expressionevaluator.Function;
 import org.gvsig.expressionevaluator.Interpreter;
@@ -212,9 +213,11 @@
                             boolean canOptimize = true;
                             if (caller.parameters() != null) {
                                 newArgs = (BaseCodes) this.getCodeBuilder().args();
-                                for (Code arg : caller.parameters()) {
+                                Codes parameters = caller.parameters();
+                                for (int i = 0; i < parameters.size(); i++) {
+                                    Code arg = parameters.get(i);
                                     Code newArg = this.doOptimize(arg);
-                                    newArgs.add(newArg);
+                                    newArgs.add(parameters.getName(i), newArg);
                                     if (newArg.code() != Code.CONSTANT) {
                                         canOptimize = false;
                                     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/grammars/BasicGrammarFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/grammars/BasicGrammarFactory.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/grammars/BasicGrammarFactory.java	(revision 44738)
@@ -20,6 +20,7 @@
 import org.gvsig.expressionevaluator.impl.function.programming.CodeBlockWithExceptFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.CreateFnFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.ForEachFunction;
+import org.gvsig.expressionevaluator.impl.function.programming.ForFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.ReturnFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.WhileFunction;
 import org.gvsig.expressionevaluator.spi.AbstractGrammarFactory;
@@ -129,16 +130,20 @@
             theGrammar.addStatement(stmt);
 
 //            stmt = theGrammar.createStatement("FOR");
-//            stmt.addRule(stmt.require_token("FOR"));
+//            stmt.addRule(stmt.require_any_token("FOR"));
 //            stmt.addRule(stmt.require_expression("INIT"));
-//            stmt.addRule(stmt.require_token(";"));
+//            stmt.addRule(stmt.require_any_token(";"));
 //            stmt.addRule(stmt.require_expression("CONDITION"));
-//            stmt.addRule(stmt.require_token(";"));
+//            stmt.addRule(stmt.require_any_token(";"));
 //            stmt.addRule(stmt.require_expression("STEP"));
-//            stmt.addRule(stmt.optional_token(":"));
+//            stmt.addRule(stmt.require_any_token("BEGIN", ":"));
 //            stmt.addRule(stmt.require_expression("BODY"));
-//            stmt.addRule(stmt.optional_token("END"));
-//            stmt.code(ForFunction.NAME,"INIT","CONDITION","STEP","BODY"); 
+//            stmt.addRule(stmt.require_any_token("END"));
+//            stmt.addRule(stmt.optional_any_token("FOR"));
+//            stmt.code(
+//                    ForFunction.NAME,
+//                    stmt.args_names("INIT","CONDITION","STEP","BODY")
+//            ); 
 //            theGrammar.addStatement(stmt);
 
             stmt = theGrammar.createStatement("FOREACH");
@@ -182,7 +187,7 @@
             stmt.addRule(stmt.optional_any_token("FUNCTION", "PROCEDURE"));
             stmt.addRule(stmt.require_identifier("FUNCTION_NAME"));
             stmt.addRule(stmt.optional_any_token("("));
-            stmt.addRule(stmt.optional_identifiers("PARAM_NAMES", ","));
+            stmt.addRule(stmt.optional_identifiers("PARAMETERS", ","));
             stmt.addRule(stmt.optional_any_token(")"));
             stmt.addRule(stmt.require_any_token("AS"));
             stmt.addRule(stmt.optional_any_token("$$","BEGIN")
@@ -203,7 +208,7 @@
 //            stmt.addRule(stmt.optional_any_token("FUNCTION", "PROCEDURE"));
             stmt.code(
                     CreateFnFunction.NAME,
-                    stmt.args_names("FUNCTION_NAME","PARAM_NAMES","BODY", "SCRIPT_PATH", "SCRIPT_FUNCTION", "LANGUAGE")
+                    stmt.args_names("FUNCTION_NAME","PARAMETERS","BODY", "SCRIPT_PATH", "SCRIPT_FUNCTION", "LANGUAGE")
             ); 
             theGrammar.addStatement(stmt);
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultGrammar.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultGrammar.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultGrammar.java	(revision 44738)
@@ -50,8 +50,10 @@
 
     @Override
     public Statement getApplicableStatement(StatementContext context) {
+        context.trace(this.getName()+".getApplicableStatement");
         for (Statement statement : statements) {
             if( statement.isApplicable(context) ) {
+                context.trace(this.getName()+".getApplicableStatement return "+statement);
                 return statement;
             }
         }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ListFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ListFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ListFunction.java	(revision 44738)
@@ -20,7 +20,6 @@
                 "List",
                 false
         );
-        this.addAlias("array");
     }
 
     @Override
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CaseFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CaseFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CaseFunction.java	(revision 44738)
@@ -26,6 +26,11 @@
     }
 
     @Override
+    public boolean isHidden() {
+      return true;
+    }
+    
+    @Override
     public boolean useArgumentsInsteadObjects() {
         return true;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/TryFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/TryFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/TryFunction.java	(revision 44738)
@@ -23,6 +23,11 @@
     }
 
     @Override
+    public boolean isHidden() {
+      return true;
+    }
+    
+    @Override
     public boolean useArgumentsInsteadObjects() {
         return true;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ReturnFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ReturnFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ReturnFunction.java	(revision 44738)
@@ -22,6 +22,11 @@
     }
 
     @Override
+    public boolean isHidden() {
+      return true;
+    }
+    
+    @Override
     public boolean allowConstantFolding() {
         return false;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CodeBlockFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CodeBlockFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CodeBlockFunction.java	(revision 44738)
@@ -25,6 +25,11 @@
     }
 
     @Override
+    public boolean isHidden() {
+      return true;
+    }
+    
+    @Override
     public boolean useArgumentsInsteadObjects() {
         return true;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ForFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ForFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ForFunction.java	(revision 44738)
@@ -23,6 +23,11 @@
     }
 
     @Override
+    public boolean isHidden() {
+      return true;
+    }
+    
+    @Override
     public boolean useArgumentsInsteadObjects() {
         return true;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CreateFnFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CreateFnFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CreateFnFunction.java	(revision 44738)
@@ -4,7 +4,6 @@
 import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.List;
-import java.util.Objects;
 import org.apache.commons.lang3.Range;
 import org.apache.commons.lang3.StringUtils;
 import org.gvsig.expressionevaluator.Code;
@@ -39,6 +38,11 @@
     }
 
     @Override
+    public boolean isHidden() {
+      return true;
+    }
+    
+    @Override
     public boolean useArgumentsInsteadObjects() {
         return true;
     }
@@ -47,6 +51,11 @@
     public boolean allowConstantFolding() {
         return false;
     }
+
+    @Override
+    public boolean allowArgNames() {
+      return true;
+    }
     
     @Override
     public Object call(Interpreter interpreter, Object[] args) throws Exception {
@@ -55,52 +64,17 @@
     
     @Override
     public Object call(Interpreter interpreter, Codes args) throws Exception {
-        // FNAME, PARAM-NAMES, BODY
         if( !(interpreter.getSymbolTable() instanceof MutableSymbolTable) ) {
             throw new ExpressionRuntimeException("The use of user functions require a mutable symbol table.");
         }
         MutableSymbolTable symbolTable = (MutableSymbolTable) interpreter.getSymbolTable();
         
-        String name;
-        List<String> argNames;
-        Code body = null;
-        String script_path = null;
-        String script_function = null;
-        String language = null;
-        // name, body
-        // name, args, body
-        // name, script_name, script_func, lang
-        // name, args, script_name, script_func, lang
-        switch(args.size()) {
-            case 2:
-                name = (String) getObject(interpreter, args, 0);
-                argNames = null;
-                body = args.get(1);
-                break;
-            case 3:
-                name = (String) getObject(interpreter, args, 0);
-                if( args.get(1)==null ) {
-                    argNames = null;
-                } else {
-                    argNames = (List<String>) getObject(interpreter, args, 1);
-                }
-                body = args.get(2);
-                break;
-            case 6:
-                name = (String) getObject(interpreter, args, 0);
-                if( args.get(1)==null ) {
-                    argNames = null;
-                } else {
-                    argNames = (List<String>) getObject(interpreter, args, 1);
-                }
-                body = args.get(2);
-                script_path = (args.get(3)==null)? null:((String)((Code.Constant)args.get(3)).value());
-                script_function = (args.get(4)==null)? null:((String)((Code.Constant)args.get(4)).value());
-                language = (args.get(5)==null)? null:((String)((Code.Constant)args.get(5)).value()).toLowerCase();
-                break;
-            default:
-                throw new ExpressionRuntimeException("Incorrect number of arguments");
-        }
+        String name = (String) getObject(interpreter, args, "FUNCTION_NAME");
+        List<String> argNames = (List<String>) getObject(interpreter, args, "PARAMETERS");
+        Code body = args.get("BODY");
+        String script_path = (String) getObject(interpreter, args, "SCRIPT_PATH");
+        String script_function = (String) getObject(interpreter, args, "SCRIPT_FUNCTION");
+        String language = (String) getObject(interpreter, args, "LANGUAGE");
         Function fn;
         if( body!=null ) {
             fn = new UserFunction(name, argNames, body);
@@ -136,8 +110,13 @@
             this.argNames = argNames;
             this.body = body;
         }
-        
+
         @Override
+        public boolean allowArgNames() {
+          return true;
+        }
+
+        @Override
         public Object call(Interpreter interpreter, Object[] args) throws Exception {
             Object value;
             ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/TupleFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/TupleFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/TupleFunction.java	(revision 44738)
@@ -1,13 +1,10 @@
 package org.gvsig.expressionevaluator.impl.function.programming;
 
-import java.util.ArrayList;
-import java.util.Arrays;
 import org.apache.commons.lang3.Range;
 import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_TUPLE;
 import org.gvsig.expressionevaluator.Function;
 import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.spi.AbstractFunction;
-import org.gvsig.tools.util.UnmodifiableBasicListAdapter;
 
 public class TupleFunction extends AbstractFunction {
     
@@ -21,6 +18,7 @@
                 "TUPLE",
                 false
         );
+        this.addAlias("ARRAY");
     }
 
     @Override
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CodeBlockWithExceptFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CodeBlockWithExceptFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/CodeBlockWithExceptFunction.java	(revision 44738)
@@ -25,6 +25,11 @@
     }
 
     @Override
+    public boolean isHidden() {
+      return true;
+    }
+    
+    @Override
     public boolean useArgumentsInsteadObjects() {
         return true;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ForEachFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ForEachFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/ForEachFunction.java	(revision 44738)
@@ -25,6 +25,11 @@
     }
 
     @Override
+    public boolean isHidden() {
+      return true;
+    }
+    
+    @Override
     public boolean useArgumentsInsteadObjects() {
         return true;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/WhileFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/WhileFunction.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/programming/WhileFunction.java	(revision 44738)
@@ -24,6 +24,11 @@
     }
 
     @Override
+    public boolean isHidden() {
+      return true;
+    }
+    
+    @Override
     public boolean useArgumentsInsteadObjects() {
         return true;
     }
